diff -r 65ffcdd09223 src/common/connection_handlers_events.py
--- a/src/common/connection_handlers_events.py	Sun Jan 31 19:58:51 2016 +0100
+++ b/src/common/connection_handlers_events.py	Fri Feb 05 14:46:16 2016 +0100
@@ -1376,7 +1376,7 @@
 
     def generate(self):
         self.stanza = self.msg_obj.stanza
-        self.id_ = self.msg_obj.id_
+        self.get_id()
         self.jid = self.msg_obj.jid
         self.fjid = self.msg_obj.fjid
         self.resource = self.msg_obj.resource
@@ -2315,6 +2315,9 @@
                 self.control_focused = True
 
     def handle_incoming_msg_event(self, msg_obj):
+        # don't alert for carbon copied messages from ourselves
+        if msg_obj.sent:
+            return
         if not msg_obj.msgtxt:
             return
         self.jid = msg_obj.jid
diff -r 65ffcdd09223 src/roster_window.py
--- a/src/roster_window.py	Sun Jan 31 19:58:51 2016 +0100
+++ b/src/roster_window.py	Fri Feb 05 14:46:16 2016 +0100
@@ -2756,15 +2756,17 @@
             return
         if obj.session.control and obj.mtype == 'chat':
             typ = ''
+            xep0184_id = None
             if obj.mtype == 'error':
                 typ = 'error'
             if obj.forwarded and obj.sent:
                 typ = 'out'
+                xep0184_id = obj.id_
 
             obj.session.control.print_conversation(obj.msgtxt, typ,
                 tim=obj.timestamp, encrypted=obj.encrypted, subject=obj.subject,
                 xhtml=obj.xhtml, displaymarking=obj.displaymarking,
-                msg_id=obj.msg_id, correct_id=(obj.id_, obj.correct_id))
+                msg_id=obj.msg_id, correct_id=(obj.id_, obj.correct_id), xep0184_id=xep0184_id)
             if obj.msg_id:
                 pw = obj.session.control.parent_win
                 end = obj.session.control.was_at_the_end
